## rspamd 3.11.1

=== debian/changelog ===
rspamd (3.11.1-4) unstable; urgency=medium

  * d/control: Drop loong64 and powerpc architectures too

 -- Jerome Lebleu <jerome@maroufle.fr>  Wed, 14 May 2025 15:46:38 +0200

rspamd (3.11.1-3) unstable; urgency=medium

  * d/control:
    + Add valkey-server as an alternative to redis-server in Recommends
    + Drop architectures where LuaJIT is not available or not fully
      working (Closes: #1104755)

 -- Jerome Lebleu <jerome@maroufle.fr>  Tue, 13 May 2025 18:11:43 +0200

rspamd (3.11.1-2) unstable; urgency=medium

  * d/tests: Wait until all TLD suffixes have been compiled

 -- Jerome Lebleu <jerome@maroufle.fr>  Thu, 24 Apr 2025 19:06:15 +0200

rspamd (3.11.1-1) unstable; urgency=medium

  * New upstream version 3.11.1 (Closes: #1072644)
  * d/lintian-overrides: Silence depends-on-obsolete-bootstrap for
    Glyphicons Halflings font
  * d/patches:
    + Refresh patches and remove merged ones
    + Do not set UTS #46 nontransitional option

 -- Jerome Lebleu <jerome@maroufle.fr>  Sun, 20 Apr 2025 17:33:02 +0200

rspamd (3.11.0-1) UNRELEASED; urgency=medium

  [ Christian Göttsche ]
  * Drop obsolete libunwind support
  * Use system libraries where supported

  [ Jerome Lebleu ]
  * New upstream version 3.11.0
  * d/control:
    + Add libarchive-dev to Build-Depends
    + Add libvectorscan-dev as an alternative to libhyperscan-dev
    + Update architectures of libluajit-5.1-dev and libunwind-dev
    + Replace libjs-bootstrap4 by libjs-bootstrap5
    + Bump Standards-Version to 4.7.2
  * d/patches:
    + Refresh patches
    + Regenerate man pages with Pandoc
    + Remove 0003-add-versions-to-shared-libraries
    + Fix Getop issues in rspamd_stats.pl
  * d/rules:
    + Move systemd directory to /usr
    + Update some configuration variables with upstream
    + Enable Link Time Optimization if supported
    + Remove useless dh_auto_clean override
    + Change how features togglers are defined
    + Export build flags for CMake
    + Use Ninja for the build system

 -- Jerome Lebleu <jerome@maroufle.fr>  Wed, 26 Feb 2025 11:41:06 +0100

=== debian/control ===
Source: rspamd
Section: mail
Priority: optional
Maintainer: Sebastien Badia <sbadia@debian.org>
Uploaders: Mikhail Gusarov <dottedmag@debian.org>,
           Jerome Lebleu <jerome@maroufle.fr>,
           Sergio Durigan Junior <sergiodj@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doctest-dev,
               libarchive-dev,
               libglib2.0-dev,
               libicu-dev,
               libjemalloc-dev,
               libluajit-5.1-dev,
               libpcre2-dev,
               libsodium-dev,
               libsqlite3-dev,
               libssl-dev,
               libvectorscan-dev [amd64 arm64] | libhyperscan-dev [i386],
               libxxhash-dev,
               libzstd-dev,
               ninja-build,
               ragel,
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://rspamd.com
Vcs-Git: https://salsa.debian.org/debian/rspamd.git
Vcs-Browser: https://salsa.debian.org/debian/rspamd

Package: rspamd
# LuaJIT is currently the only way to provide the FFI library which is used by
# several internel modules. In the meantime, architectures for which LuaJIT is
# unavailable are removed to not provide an unstable package. Note that s390x,
# loong64 and powerpc are removed due to unexpected test results - see #1104755.
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel riscv64
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         ca-certificates,
         fonts-glyphicons-halflings,
         libjs-bootstrap5,
         libjs-jquery,
         libjs-requirejs,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: valkey-server | redis-server
Description: Rapid spam filtering system
 Rspamd is a rapid, modular and lightweight spam filter. It is designed to work
 with big amount of mail and can be easily extended with own filters written in
 Lua.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# CMake doesn't honor CPPFLAGS
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)
ASMFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS ASMFLAGS LDFLAGS

ENABLE_HYPERSCAN := -DENABLE_HYPERSCAN=OFF

ifneq ($(filter amd64 arm64 i386, $(DEB_HOST_ARCH)),)
  ENABLE_HYPERSCAN := -DENABLE_HYPERSCAN=ON
endif

%:
	dh $@ --buildsystem=cmake+ninja --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCONFDIR=/etc/rspamd \
		-DMANDIR=/usr/share/man \
		-DRUNDIR=/run/rspamd \
		-DDBDIR=/var/lib/rspamd \
		-DLOGDIR=/var/log/rspamd \
		-DSHAREDIR=/usr/share/rspamd \
		-DLIBDIR=/usr/lib/rspamd \
		-DINCLUDEDIR=/usr/include \
		-DSYSTEMDDIR=/usr/lib/systemd/system \
		-DWANT_SYSTEMD_UNITS=ON \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_BUILD_WITH_INSTALL_RPATH=OFF \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DNO_SHARED=ON \
		-DNO_TARGET_VERSIONS=ON \
		-DENABLE_LIBCXX=OFF \
		-DENABLE_LTO=ON \
		-DENABLE_FULL_DEBUG=OFF \
		-DENABLE_JEMALLOC=ON \
		-DENABLE_OPTIMIZATION=OFF \
		-DENABLE_PCRE2=ON \
		-DSYSTEM_ZSTD=ON \
		-DSYSTEM_DOCTEST=ON \
		-DSYSTEM_XXHASH=ON \
		-DENABLE_LUAJIT=ON \
		$(ENABLE_HYPERSCAN)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ninja -C build run-test
endif

override_dh_makeshlibs:
	dh_makeshlibs -Xlibrspamd-actrie -Xlibrspamd-ev -Xlibrspamd-kann -Xlibrspamd-replxx -Xlibrspamd-server

override_dh_fixperms:
	dh_fixperms
	chmod 750 $(CURDIR)/debian/rspamd/var/lib/rspamd
	chmod 750 $(CURDIR)/debian/rspamd/var/log/rspamd

## rspamd 3.12.1

=== CMakeLists.txt ===
#
# Rspamd - rapid antispam system
#
# Cmake configuration file
#

############################# INITIAL SECTION #############################################
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

# Define version variables
set(RSPAMD_VERSION_MAJOR 3)
set(RSPAMD_VERSION_MINOR 12)
set(RSPAMD_VERSION_PATCH 1)

# Keep two digits all the time
set(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
set(RSPAMD_VERSION_MINOR_NUM ${RSPAMD_VERSION_MINOR}0)
set(RSPAMD_VERSION_PATCH_NUM ${RSPAMD_VERSION_PATCH}0)

if (GIT_ID)
    set(GIT_VERSION 1)
    set(RSPAMD_ID "${GIT_ID}")
endif ()

set(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}.${RSPAMD_VERSION_PATCH}")

project(rspamd
        VERSION "${RSPAMD_VERSION}"
        LANGUAGES C CXX ASM
        DESCRIPTION "Rapid spam filtering system"
        HOMEPAGE_URL "https://rspamd.com"
)

cmake_policy(SET CMP0075 NEW)

# Language standards
set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")

set(RSPAMD_MASTER_SITE_URL "https://rspamd.com")

if (NOT RSPAMD_USER)
    set(RSPAMD_USER "nobody")
    set(RSPAMD_GROUP "nobody")
endif ()

# Default for SysV Init
set(RSPAMD_WORKER_NORMAL "*:11333")
set(RSPAMD_WORKER_CONTROLLER "*:11334")

############################# OPTIONS SECTION #############################################
option(ENABLE_LUAJIT "Link with libluajit" ON)
option(ENABLE_URL_INCLUDE "Enable URLs in UCL includes (requires libcurl or libfetch)" OFF)
option(NO_SHARED "Build internal libs static" ON)
option(INSTALL_WEBUI "Install web interface" ON)
option(INSTALL_EXAMPLES "Install examples of the configuration and Lua" ON)
option(WANT_SYSTEMD_UNITS "Install systemd unit files on Linux" OFF)
option(ENABLE_SNOWBALL "Enable snowball stemmer" ON)
option(ENABLE_CLANG_PLUGIN "Enable clang static analysing plugin" OFF)
option(ENABLE_PCRE2 "Enable pcre2 instead of pcre" ON)
option(ENABLE_JEMALLOC "Build rspamd with jemalloc allocator" OFF)
option(ENABLE_UTILS "Build rspamd internal utils" OFF)
option(ENABLE_LIBUNWIND "Obsoleted" OFF) # Deprecated option
option(ENABLE_LUA_TRACE "Trace all Lua C API invocations" OFF)
option(ENABLE_FASTTEXT "Link with FastText library" OFF)
option(ENABLE_BACKWARD "Build rspamd with backward-cpp stacktrace" ON)
option(SYSTEM_ZSTD "Use system zstd instead of bundled one" OFF)
option(SYSTEM_DOCTEST "Use system doctest instead of bundled one" OFF)
option(SYSTEM_XXHASH "Use system xxhash instead of bundled one" OFF)

############################# INCLUDE SECTION #############################################

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckLibraryExists)
include(CheckCCompilerFlag)
include(CMakeParseArguments)
include(FindArch)
include(AsmOp)
include(FindRagel)
include(ProcessPackage)

if (NOT RAGEL_FOUND)
    message(FATAL_ERROR "Ragel is required to build rspamd")
endif ()

# Find required packages
find_package(PkgConfig REQUIRED)
find_package(Perl REQUIRED)

# Sanitizer setup
option(SANITIZE "Enable sanitizer: address, memory, undefined, leak (comma separated list)" "")
include(Toolset)
include(Sanitizer)

include(ArchDep)
include(Paths)

include(OSDep)
ConfigurePlatformSpecifics()

if (ENABLE_PCRE2)
    set(WITH_PCRE2 1)
    # For utf8 API
    list(APPEND CMAKE_REQUIRED_DEFINITIONS "-DPCRE2_CODE_UNIT_WIDTH=8")
endif ()

############################# CONFIG SECTION #############################################
# Include directories
# Prefer local include dirs to system ones
include_directories(
        "${CMAKE_SOURCE_DIR}/"
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/src/libutil"
        "${CMAKE_SOURCE_DIR}/src/libserver"
        "${CMAKE_SOURCE_DIR}/src/libmime"
        "${CMAKE_SOURCE_DIR}/src/libstat"
        "${CMAKE_SOURCE_DIR}/src/libcryptobox"
        "${CMAKE_SOURCE_DIR}/contrib/libucl"
        "${CMAKE_SOURCE_DIR}/contrib/replxx/include"
        "${CMAKE_SOURCE_DIR}/contrib/uthash"
        "${CMAKE_SOURCE_DIR}/contrib/http-parser"
        "${CMAKE_SOURCE_DIR}/contrib/fpconv"
        "${CMAKE_SOURCE_DIR}/contrib/libottery"
        "${CMAKE_SOURCE_DIR}/contrib/cdb"
        "${CMAKE_SOURCE_DIR}/contrib/snowball/include"
        "${CMAKE_SOURCE_DIR}/contrib/librdns"
        "${CMAKE_SOURCE_DIR}/contrib/aho-corasick"
        "${CMAKE_SOURCE_DIR}/contrib/lc-btrie"
        "${CMAKE_SOURCE_DIR}/contrib/lua-lpeg"
        "${CMAKE_SOURCE_DIR}/contrib/frozen/include"
        "${CMAKE_SOURCE_DIR}/contrib/fu2/include"
        "${CMAKE_BINARY_DIR}/src" # Stored in the binary dir
        "${CMAKE_BINARY_DIR}/src/libcryptobox"
)

set(TAR "tar")
include(OSDep)

# Now find libraries and headers
list(APPEND RSPAMD_REQUIRED_LIBRARIES "m")
list(APPEND RSPAMD_REQUIRED_LIBRARIES "pthread")

# Lua setup
if (ENABLE_LUAJIT)
    ProcessPackage(LIBLUAJIT LIBRARY "luajit"
            "luajit-2.1"
            "luajit2.1"
            "luajit-2.0"
            "luajit2.0"
            "luajit-5.1"
            INCLUDE luajit.h INCLUDE_SUFFIXES
            "include/luajit-2.1"
            "include/luajit-2.0"
            "include/luajit"
            ROOT ${LUA_ROOT}
            MODULES luajit)
    set(WITH_LUAJIT 1)
else ()
    # Try to find Lua (5.3, 5.4, 5.2, or 5.1 in that order)
    ProcessPackage(LIBLUA LIBRARY "lua"
            "lua-5.3"
            LIB_SUFFIXES "lua5.3"
            INCLUDE lua.h INCLUDE_SUFFIXES
            "include/lua-5.3"
            "include/lua5.3"
            "include/lua53"
            "include/lua"
            ROOT ${LUA_ROOT}
            MODULES lua53
            OPTIONAL)

    if (NOT WITH_LIBLUA)
        ProcessPackage(LIBLUA LIBRARY "lua"
                "lua-5.4"
                LIB_SUFFIXES "lua5.4"
                INCLUDE lua.h INCLUDE_SUFFIXES
                "include/lua-5.4"
                "include/lua5.4"
                "include/lua54"
                "include/lua"
                ROOT ${LUA_ROOT}
                MODULES lua54
                OPTIONAL)
        if (NOT WITH_LIBLUA)
            ProcessPackage(LIBLUA LIBRARY "lua"
                    "lua-5.2"
                    LIB_SUFFIXES "lua5.2"
                    INCLUDE lua.h INCLUDE_SUFFIXES
                    "include/lua-5.2"
                    "include/lua5.2"
                    "include/lua52"
                    "include/lua"
                    ROOT ${LUA_ROOT}
                    MODULES lua52
                    OPTIONAL)

            if (NOT WITH_LIBLUA)
                ProcessPackage(LIBLUA LIBRARY "lua"
                        "lua-5.1"
                        INCLUDE lua.h INCLUDE_SUFFIXES
                        "include/lua-5.1"
                        "include/lua5.1"
                        "include/lua51"
                        "include/lua"
                        ROOT ${LUA_ROOT}
                        MODULES lua51)
            endif ()
        endif ()
    endif ()
endif ()

# Memory allocator
if (ENABLE_JEMALLOC AND NOT SANITIZE)
    ProcessPackage(JEMALLOC LIBRARY jemalloc_pic jemalloc INCLUDE jemalloc/jemalloc.h
            ROOT ${JEMALLOC_ROOT_DIR})
    set(WITH_JEMALLOC "1")
endif ()

# Required libraries
ProcessPackage(GLIB2 LIBRARY glib-2.0 INCLUDE glib.h
        INCLUDE_SUFFIXES include/glib include/glib-2.0
        ROOT ${GLIB_ROOT_DIR} MODULES glib-2.0>=2.28)

# PCRE setup
if (ENABLE_PCRE2)
    ProcessPackage(PCRE LIBRARY pcre2 pcre2-8 INCLUDE pcre2.h INCLUDE_SUFFIXES include/pcre2
            ROOT ${PCRE_ROOT_DIR} MODULES pcre2 pcre2-8 libpcre2 libpcre2-8)
else ()
    ProcessPackage(PCRE LIBRARY pcre INCLUDE pcre.h INCLUDE_SUFFIXES include/pcre
            ROOT ${PCRE_ROOT_DIR} MODULES pcre libpcre pcre3 libpcre3)
endif ()

# Other dependencies
ProcessPackage(SQLITE3 LIBRARY sqlite3 INCLUDE sqlite3.h INCLUDE_SUFFIXES include/sqlite3 include/sqlite
        ROOT ${SQLITE3_ROOT_DIR} MODULES sqlite3 sqlite)
ProcessPackage(ICUDATA LIBRARY icudata INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUC LIBRARY icuuc INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUIO LIBRARY icuio INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-io)
ProcessPackage(ICUI18N LIBRARY icui18n INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-i18n)
ProcessPackage(LIBCRYPT LIBRARY crypto INCLUDE openssl/evp.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libcrypt)
ProcessPackage(LIBSSL LIBRARY ssl INCLUDE openssl/ssl.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libssl)
ProcessPackage(LIBZ LIBRARY z INCLUDE zlib.h INCLUDE_SUFFIXES include/zlib
        ROOT ${LIBZ_ROOT_DIR} MODULES z)
ProcessPackage(SODIUM LIBRARY sodium INCLUDE sodium.h
        INCLUDE_SUFFIXES include/libsodium include/sodium
        ROOT ${LIBSODIUM_ROOT_DIR} MODULES libsodium>=1.0.0)
ProcessPackage(LIBARCHIVE LIBRARY archive INCLUDE archive.h
        ROOT ${LIBARCHIVE_ROOT_DIR} MODULES libarchive>=3.0.0)

if (ENABLE_FASTTEXT)
    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext/fasttext.h
            ROOT ${FASTTEXT_ROOT_DIR} MODULES fasttext)
    set(WITH_FASTTEXT "1")
endif ()

# Include common compiler and platform specific configurations
include(CompilerWarnings)
include(Hyperscan)
include(Openblas)

# Lua tracing
if (ENABLE_LUA_TRACE)
    set(WITH_LUA_TRACE 1)
endif ()

# Configure compiler flags
set(CMAKE_C_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_CXX_FLAGS}")

# Define macros for compilation
add_definitions(-DHAVE_CONFIG_H)
add_definitions(-DDOCTEST_CONFIG_NO_MULTI_LANE_ATOMICS)
add_definitions(-DFMT_HEADER_ONLY)
# Workaround for https://github.com/onqtam/doctest/issues/356
add_definitions(-DDOCTEST_CONFIG_USE_STD_HEADERS)
add_definitions(-DU_CHARSET_IS_UTF8)
# Disable zstd deprecation warnings, as they are not relevant for us
add_definitions(-DZSTD_DISABLE_DEPRECATE_WARNINGS)

# Check platform specific includes
include(CheckSystemHeaders)

# Check macros, functions, and features
include(CheckSystemFeatures)

# Check symbols and functions
include(CheckSymbols)

# Configure PIC support
check_c_compiler_flag(-fPIC SUPPORT_FPIC)
if (SUPPORT_FPIC)
    add_compile_options("-fPIC")
endif ()

# Support for URL includes
include(CheckURLInclude)
if (ENABLE_URL_INCLUDE)
    CheckURLIncludeSupport()
endif ()

# Ensure DESTDIR is set
if (NOT DESTDIR)
    set(DESTDIR $ENV{DESTDIR})
endif ()

################################ SUBDIRS SECTION ###########################
# Add required subdirectories for dependencies
include(AddDependencySubdirectories)
AddDependencySubdirectories()

############################ TARGETS SECTION ###############################

# Generate config.h
configure_file(config.h.in src/config.h)

##################### INSTALLATION ##########################################
# Setup installation targets
include(InstallRspamdFiles)
InstallRspamdFiles()

# Build distribution and testing targets
add_custom_target(dist ${CMAKE_SOURCE_DIR}/dist.sh
        "${CMAKE_BINARY_DIR}/rspamd-${RSPAMD_VERSION}.tar.xz" "${TAR}"
        COMMENT "Create source distribution"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# Tests
# Include CTest for testing support
include(CTest)
enable_testing()
add_subdirectory(test)

add_custom_target(check DEPENDS rspamd-test-cxx rspamd-test)
add_custom_target(run-test DEPENDS check
        COMMAND test/rspamd-test-cxx
        COMMAND sh -c 'LUA_PATH="${CMAKE_SOURCE_DIR}/lualib/?.lua\;${CMAKE_SOURCE_DIR}/lualib/?/?.lua\;${CMAKE_SOURCE_DIR}/lualib/?/init.lua\;${CMAKE_SOURCE_DIR}/contrib/lua-?/?.lua"
        test/rspamd-test -p /rspamd/lua')

# Setup PVS Studio if available
include(SetupPVSStudio)
SetupPVSStudio()

=== contrib/aho-corasick/CMakeLists.txt ===
SET(AHOCORASICSRC	acism_create.c
					acism.c)

IF(NOT GPL_RSPAMD_BINARY)
	ADD_LIBRARY(rspamd-actrie SHARED ${AHOCORASICSRC})
	target_link_libraries(rspamd-actrie glib-2.0)
	target_link_libraries(rspamd-actrie "${RSPAMD_REQUIRED_LIBRARIES}")

	INSTALL(TARGETS rspamd-actrie
			LIBRARY DESTINATION ${RSPAMD_LIBDIR})
ELSE()
	ADD_LIBRARY(rspamd-actrie STATIC ${AHOCORASICSRC})
	target_link_libraries(rspamd-actrie glib-2.0)
ENDIF()

=== contrib/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.15)
project(backward CXX)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

if (DEFINED ENV{OMPI_CXX} OR DEFINED ENV{MPICH_CXX})
   if ( ($ENV{OMPI_CXX} MATCHES "nvcc") OR ($ENV{MPICH_CXX} MATCHES "nvcc") )
     set(COMPILER_IS_NVCC true)
   endif()
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

=== contrib/google-ced/CMakeLists.txt ===
# Copyright 2016 Google Inc.  All Rights Reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.
#
# This library is derived from https://github.com/google/compact_enc_det
# git id: 37529e628fbac2e4c0d4d8520be9db789f316c9e

project(CED CXX)
set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE INTERNAL "No dev warnings")

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wno-narrowing")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(CED_LIBRARY_SOURCES
    compact_enc_det.cc
    compact_enc_det_hint_code.cc
    util/encodings/encodings.cc
    util/languages/languages.cc
    ced_c.cc
    )

add_library(rspamd-ced STATIC ${CED_LIBRARY_SOURCES})

=== contrib/zstd/CMakeLists.txt ===
SET(ZSTDSRC
		debug.c
		divsufsort.c
		entropy_common.c
		error_private.c
		fse_compress.c
		fse_decompress.c
		hist.c
		huf_compress.c
		huf_decompress.c
		pool.c
		zstd_common.c
		zstd_compress.c
		zstd_compress_literals.c
		zstd_compress_sequences.c
		zstd_compress_superblock.c
		zstd_ddict.c
		zstd_decompress.c
		zstd_decompress_block.c
		zstd_double_fast.c
		zstd_fast.c
		zstd_lazy.c
		zstd_ldm.c
		zstd_opt.c)

ADD_LIBRARY(rspamd-zstd STATIC ${ZSTDSRC})
ADD_DEFINITIONS(-DZSTD_DISABLE_ASM -DZSTD_DISABLE_DEPRECATE_WARNINGS)

=== src/libstat/CMakeLists.txt ===
# Librspamdserver
SET(LIBSTATSRC		${CMAKE_CURRENT_SOURCE_DIR}/stat_config.c
					${CMAKE_CURRENT_SOURCE_DIR}/stat_process.c)

SET(TOKENIZERSSRC	${CMAKE_CURRENT_SOURCE_DIR}/tokenizers/tokenizers.c
					${CMAKE_CURRENT_SOURCE_DIR}/tokenizers/osb.c)

SET(CLASSIFIERSSRC	${CMAKE_CURRENT_SOURCE_DIR}/classifiers/bayes.c
					${CMAKE_CURRENT_SOURCE_DIR}/classifiers/lua_classifier.c)

SET(BACKENDSSRC 	${CMAKE_CURRENT_SOURCE_DIR}/backends/mmaped_file.c
					${CMAKE_CURRENT_SOURCE_DIR}/backends/sqlite3_backend.c
					${CMAKE_CURRENT_SOURCE_DIR}/backends/cdb_backend.cxx
					${CMAKE_CURRENT_SOURCE_DIR}/backends/http_backend.cxx
					${CMAKE_CURRENT_SOURCE_DIR}/backends/redis_backend.cxx)

SET(CACHESSRC 	${CMAKE_CURRENT_SOURCE_DIR}/learn_cache/sqlite3_cache.c
        ${CMAKE_CURRENT_SOURCE_DIR}/learn_cache/redis_cache.cxx)

SET(RSPAMD_STAT ${LIBSTATSRC}
			${TOKENIZERSSRC}
			${CLASSIFIERSSRC}
			${BACKENDSSRC}
			${CACHESSRC} PARENT_SCOPE)

=== src/lua/CMakeLists.txt ===
# Lua support makefile
SET(LUASRC			  ${CMAKE_CURRENT_SOURCE_DIR}/lua_common.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_logger.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_task.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_config.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_classifier.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_cfg_file.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_regexp.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_cdb.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_xmlrpc.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_http.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_redis.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_upstream.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_mempool.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_dns_resolver.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_rsa.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_ip.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_expression.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_trie.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_mimepart.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_url.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_util.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_tcp.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_html.cxx
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_sqlite3.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_cryptobox.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_map.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_thread_pool.cxx
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_dns.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_udp.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_text.c
		 			  ${CMAKE_CURRENT_SOURCE_DIR}/lua_worker.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_kann.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_spf.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_tensor.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_parsers.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_compress.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_classnames.c
					  ${CMAKE_CURRENT_SOURCE_DIR}/lua_shingles.cxx)

SET(RSPAMD_LUA ${LUASRC} PARENT_SCOPE)

=== debian/changelog ===
rspamd (3.12.1-1) unstable; urgency=medium

  [ наб ]
  * Use publicsuffix's effective_tld_names.dat instead of
    distributing an embedded copy (Closes: #985239)

  [ Jerome Lebleu ]
  * New upstream version 3.12.1
  * d/patches: Refresh patches and remove merged ones
  * d/control: Use Vectorscan only on arm64 (Closes: #1108043)

 -- Jerome Lebleu <jerome@maroufle.fr>  Tue, 24 Jun 2025 22:42:33 +0200

=== debian/rules ===
--- 
+++ 
@@ -49,6 +49,18 @@
 		-DENABLE_LUAJIT=ON \
 		$(ENABLE_HYPERSCAN)
 
+override_dh_auto_build:
+	dh_auto_build
+
+	# Do not embed scripts and fonts which are provided by other packages
+	$(RM) $(CURDIR)/interface/css/bootstrap.min.css
+	$(RM) $(CURDIR)/interface/js/lib/bootstrap.bundle.min.js
+	$(RM) $(CURDIR)/interface/js/lib/jquery-3.7.1.min.js
+	$(RM) $(CURDIR)/interface/js/lib/require.min.js
+	$(RM) $(CURDIR)/interface/fonts/glyphicons-halflings-regular.ttf
+	$(RM) $(CURDIR)/interface/fonts/glyphicons-halflings-regular.woff
+	$(RM) $(CURDIR)/interface/fonts/glyphicons-halflings-regular.woff2
+
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	ninja -C build run-test
